import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { OrderInfo, OrderInfoParam } from './model';
import { MODULES_API_URL } from '@/config/setting';

/**
 * 分页查询
 */
export async function pageOrderInfo(params: OrderInfoParam) {
  const res = await request.get<ApiResult<PageResult<OrderInfo>>>(
    MODULES_API_URL + '/shop/order-info/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询列表
 */
export async function listOrderInfo(params?: OrderInfoParam) {
  const res = await request.get<ApiResult<OrderInfo[]>>(
    MODULES_API_URL + '/shop/order-info',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加
 */
export async function addOrderInfo(data: OrderInfo) {
  const res = await request.post<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/order-info',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改
 */
export async function updateOrderInfo(data: OrderInfo) {
  const res = await request.put<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/order-info',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除
 */
export async function removeOrderInfo(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/order-info/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除
 */
export async function removeBatchOrderInfo(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/order-info/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询
 */
export async function getOrderInfo(id: number) {
  const res = await request.get<ApiResult<OrderInfo>>(
    MODULES_API_URL + '/shop/order-info/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
